package de.fhdw.wtf.tooling.editor.proposals;

import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IDocument;

public class BaseTypeProposal extends ColonOffsetProposal {
	private static BaseTypeProposal instance;
	
	public static synchronized BaseTypeProposal create() {
		if (instance == null) {
			instance = new BaseTypeProposal();
		}
		return instance;
	}
	
	private BaseTypeProposal() {
		super(new String[] { "Integer", "String" });
	}
	
	@Override
	protected boolean isValid(final char c, final int offset, final IDocument doc) {
		return c == '{' || c == '[' && this.checkValidTransitively(offset, doc);
	}
	
	@Override
	protected boolean isInvalid(final char c, final int offset, final IDocument doc) {
		return c == ']' || c == '}' || offset == 0;
	}
	
	private boolean checkValidTransitively(final int offset, final IDocument doc) {
		int offsetCopy = offset;
		while (true) {
			char c;
			try {
				if (offsetCopy > 0) {
					c = doc.getChar(--offsetCopy);
					if (c == '{') {
						return true;
					}
					if (c == '[') {
						return false;
					}
				} else {
					return false;
				}
				
			} catch (final BadLocationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
}
