package de.fhdw.wtf.tooling.editor.proposals;

import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.ITextViewer;

public class ClassModifierProposal extends ContextProposal {
	private static ClassModifierProposal instance;
	
	public static synchronized ClassModifierProposal create() {
		if (instance == null) {
			instance = new ClassModifierProposal();
		}
		return instance;
	}
	
	private ClassModifierProposal() {
		super(new String[] { "abstract", "transient", "service", "visitable" });
	}
	
	@Override
	protected Integer skipToToken(final ITextViewer viewer, final int offset) {
		return offset;
	}
	
	@Override
	protected boolean isValid(final char c, final int offset, final IDocument doc) {
		return c == '}';
	}
	
	@Override
	protected boolean isInvalid(final char c, final int offset, final IDocument doc) {
		return c == ']' || c == '{' || c == '[' || c == ';' || offset == 0;
	}
	
}
